program readflex;
//bytes als 7-channel MC-Algol flexowritercode interpreteren /Edo H. Dooijes juli 2001- maart 2017 
//output is html file met unicode tekst
//bron: Flexowriter Punching Code, MC 050262}
uses Dos, Crt;
var f: file of byte;
    g: text;
    b: byte;
    lc,stroke,underscore,carrhold: boolean; 
    q: string; 

function evenpar7(b: byte): boolean;
var b6,b5,b4,b3,b2,b1,b0: byte;
    m6,m5,m4,m3,m2,m1: byte;
begin
   b6:= b div 64; m6:=b  mod 64;
   b5:=m6 div 32; m5:=m6 mod 32;
   b4:=m5 div 16; m4:=m5 mod 16;
   b3:=m4 div 8;  m3:=m4 mod 8;
   b2:=m3 div 4;  m2:=m3 mod 4;
   b1:=m2 div 2;  m1:=m2 mod 2;
   b0:=m1;
   evenpar7:=not odd(b0+b1+b2+b3+b4+b5+b6);
end; 

procedure schrijf(c: char);
	begin 
		if underscore then 
			begin write(g,'<u>',c,'</u>'); carrhold:=false end 
		else write(g,c) 
	end;  
	
procedure carrhalted(q: string);
	begin
		write(g,q); carrhold:=false  //carriage weer vrijgegeven
	end;

begin
    if ParamCount=0 then
        begin
           writeln('usage: readflex <inputfile>');
           halt
        end; 
    q:=ParamStr(1); 
    //q:='CWI1_2';
    assign(g,q+'.html');  
    rewrite(g);
    write(g,'<html>');
    assign(f,q);    
    reset(f);
    stroke:=false; underscore:=false; carrhold:=false;
    lc:=true;
    while not eof(f) do
      begin
         read(f,b);
         b:=b mod 128;  
         if evenpar7(b) then writeln('code ',b,' has even parity');  
         case b of
         122: lc:=true;
         124: lc:=false; 
         14:  begin 
	             if lc then underscore:=true else stroke:=true;
		         carrhold:=true; //toestand bewaren tot er iets mee gedaan is
		         //if underscore then write(g,'&#8869;');    //omgekeerde T voor debuggen
			     //if (stroke) then write(g,'&#8868;')         //T voor debuggen
			  end;
         97:  if lc then schrijf('a') else schrijf('A');
         98:  if lc then schrijf('b') else schrijf('B');
         115: if lc then schrijf('c') else schrijf('C');
         100: if lc then schrijf('d') else schrijf('D');
         117: if lc then schrijf('e') else schrijf('E');
         118: if lc then schrijf('f') else schrijf('F');
         103: if lc then schrijf('g') else schrijf('G');
         104: if lc then schrijf('h') else schrijf('H');
         121: if lc then schrijf('i') else schrijf('I');
         81:  if lc then schrijf('j') else schrijf('J');
         82:  if lc then schrijf('k') else schrijf('K');
         67:  if lc then schrijf('l') else schrijf('L');
         84:  if lc then schrijf('m') else schrijf('M');
         69:  if lc then schrijf('n') else schrijf('N');
         70:  if lc then schrijf('o') else schrijf('O');
         87:  if lc then schrijf('p') else schrijf('P');
         88:  if lc then schrijf('q') else schrijf('Q');
         73:  if lc then schrijf('r') else schrijf('R');
         50:  if lc then schrijf('s') else schrijf('S');
         35:  if lc then schrijf('t') else schrijf('T');
         52:  if lc then schrijf('u') else schrijf('U');
         37:  if lc then schrijf('v') else schrijf('V');
         38:  if lc then schrijf('w') else schrijf('W');
         55:  if lc then schrijf('x') else schrijf('X');
         56:  if lc then schrijf('y') else schrijf('Y');
         41:  if lc then schrijf('z') else schrijf('Z');
         32:  if lc then write(g,'0') else  begin if stroke then carrhalted('&uarr;') else write(g,'&and;') end;  //uparrow      
         1:   if lc then write(g,'1') else write(g,'&or;'); 
         2:   if lc then write(g,'2') else write(g,'&times;');
         19:  if lc then write(g,'3') else write(g,'/');  
         4:   if lc then write(g,'4') else
                 begin
                    if stroke then carrhalted('&ne;')            //inequality  
                    else if underscore then carrhalted('&equiv;')     //equivalence 
                    else write(g,'=')
                 end;
         21:  if lc then write(g,'5') else write(g,';');
         22:  if lc then write(g,'6') else write(g,'[');
         7:   if lc then write(g,'7') else write(g,']');
         8:   if lc then write(g,'8') else write(g,'(');
         25:  if lc then write(g,'9') else write(g,')');
       
         49:  begin 
				if underscore then begin if lc then carrhalted('&le;') else carrhalted('&ge;') end;
	          	if stroke then begin if lc then carrhalted('&#8814;') else carrhalted('&#8815;') end;    //quotation marks                               
              	if not (underscore or stroke) then begin if lc then write(g,'&lt;') else write(g,'&gt;') end;    
	          end; 
        
         112: if lc then write(g,'+') else write(g,'"');   //" not used in Algol
         91:  if lc then write(g,',') else write(g,'?');   //? not used in Algol
         59:  if lc then write(g,'&#9192;') else write(g,'&prime;');   //9192: power of 10 separator                                           
         107: if lc then write(g,'.') else
                begin if underscore then carrhalted('&divide;') else write(g,':') end;  //integer division                                          
         64:  if lc then write(g,'-') else
                 begin if underscore then carrhalted('&sup;')  else write(g,'&not;') end; //implication,negation      
         62:  write(g,'   ');    //TAB
         26:  write(g,'<br>');  //NLCR = html line break
         16:  write(g,' ');   //SPACE
         127: ; //write(g,'ERASE'); 
         47:  ; //write(g,'PUNCH OFF');
         11:  ; //write(g,'STOP');
         else writeln('undefined code: ',b) 
         end; //case
         if not (carrhold) then begin stroke:=false; underscore:=false end;
      end; //while 
    write(g,'</html>');
    close(g)
end.    


         
	
	
	
	
	
	
	
	
	
	